Index: /NEMO/trunk/src/OCE/SBC/sbcblk_algo_ncar.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcblk_algo_ncar.F90	(revision 14071)
+++ /NEMO/trunk/src/OCE/SBC/sbcblk_algo_ncar.F90	(revision 14072)
@@ -5,5 +5,5 @@
    !!   * bulk transfer coefficients C_D, C_E and C_H
    !!   * air temp. and spec. hum. adjusted from zt (2m) to zu (10m) if needed
-   !!   * the effective bulk wind speed at 10m U_blk
+   !!   * the effective bulk wind speed at 10m Ubzu
    !!   => all these are used in bulk formulas in sbcblk.F90
    !!
@@ -16,4 +16,5 @@
    !!=====================================================================
    !! History :  3.6  !  2016-02  (L.Brodeau) successor of old turb_ncar of former sbcblk_core.F90
+   !!            4.2  !  2020-12  (L. Brodeau) Introduction of various air-ice bulk parameterizations + improvements
    !!----------------------------------------------------------------------
 
@@ -23,20 +24,9 @@
    !!                   returns the effective bulk wind speed at 10m
    !!----------------------------------------------------------------------
-   USE oce             ! ocean dynamics and tracers
    USE dom_oce         ! ocean space and time domain
+   USE sbc_oce, ONLY: ln_cdgw
+   USE sbcwave, ONLY: cdn_wave ! wave module
    USE phycst          ! physical constants
-   USE sbc_oce         ! Surface boundary condition: ocean fields
-   USE sbcwave, ONLY   :  cdn_wave ! wave module
-#if defined key_si3 || defined key_cice
-   USE sbc_ice         ! Surface boundary condition: ice fields
-#endif
-   !
-   USE iom             ! I/O manager library
-   USE lib_mpp         ! distribued memory computing library
-   USE in_out_manager  ! I/O manager
-   USE prtctl          ! Print control
-   USE lib_fortran     ! to use key_nosignedzero
-
-   USE sbcblk_phy      ! all thermodynamics functions, rho_air, q_sat, etc... !LB
+   USE sbc_phy         ! Catalog of functions for physical/meteorological parameters in the marine boundary layer
 
    IMPLICIT NONE
@@ -45,5 +35,4 @@
    PUBLIC :: TURB_NCAR   ! called by sbcblk.F90
 
-   INTEGER , PARAMETER ::   nb_itt = 5        ! number of itterations
    !! * Substitutions
 #  include "do_loop_substitute.h90"
@@ -52,7 +41,7 @@
 CONTAINS
 
-   SUBROUTINE turb_ncar( zt, zu, sst, t_zt, ssq, q_zt, U_zu, &
-      &                  Cd, Ch, Ce, t_zu, q_zu, U_blk,      &
-      &                  Cdn, Chn, Cen                       )
+   SUBROUTINE turb_ncar(    zt, zu, sst, t_zt, ssq, q_zt, U_zu, &
+      &                     Cd, Ch, Ce, t_zu, q_zu, Ubzu,       &
+      &                     nb_iter, CdN, ChN, CeN               )
       !!----------------------------------------------------------------------------------
       !!                      ***  ROUTINE  turb_ncar  ***
@@ -61,6 +50,5 @@
       !!                fluxes according to Large & Yeager (2004) and Large & Yeager (2008)
       !!                If relevant (zt /= zu), adjust temperature and humidity from height zt to zu
-      !!                Returns the effective bulk wind speed at 10m to be used in the bulk formulas
-      !!
+      !!                Returns the effective bulk wind speed at zu to be used in the bulk formulas
       !!
       !! INPUT :
@@ -82,6 +70,11 @@
       !!    *  t_zu   : pot. air temperature adjusted at wind height zu       [K]
       !!    *  q_zu   : specific humidity of air        //                    [kg/kg]
-      !!    *  U_blk  : bulk wind speed at zu                                 [m/s]
-      !!
+      !!    *  Ubzu   : bulk wind speed at zu                                 [m/s]
+      !!
+      !! OPTIONAL OUTPUT:
+      !! ----------------
+      !!    * CdN      : neutral-stability drag coefficient
+      !!    * ChN      : neutral-stability sensible heat coefficient
+      !!    * CeN      : neutral-stability evaporation coefficient
       !!
       !! ** Author: L. Brodeau, June 2019 / AeroBulk (https://github.com/brodeau/aerobulk/)
@@ -99,141 +92,146 @@
       REAL(wp), INTENT(  out), DIMENSION(jpi,jpj) ::   t_zu     ! pot. air temp. adjusted at zu               [K]
       REAL(wp), INTENT(  out), DIMENSION(jpi,jpj) ::   q_zu     ! spec. humidity adjusted at zu           [kg/kg]
-      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj) ::   U_blk    ! bulk wind speed at zu                     [m/s]
-      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj) ::   Cdn, Chn, Cen ! neutral transfer coefficients
-      !
-      INTEGER :: j_itt
+      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj) ::   Ubzu    ! bulk wind speed at zu                     [m/s]
+      !
+      INTEGER , INTENT(in   ), OPTIONAL                     :: nb_iter  ! number of iterations
+      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(jpi,jpj) ::   CdN
+      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(jpi,jpj) ::   ChN
+      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(jpi,jpj) ::   CeN
+      !
+      INTEGER :: nbit, jit                    ! iterations...
       LOGICAL :: l_zt_equal_zu = .FALSE.      ! if q and t are given at same height as U
       !
-      REAL(wp), DIMENSION(jpi,jpj) ::   Cx_n10        ! 10m neutral latent/sensible coefficient
-      REAL(wp), DIMENSION(jpi,jpj) ::   sqrt_Cd_n10   ! root square of Cd_n10
+      REAL(wp), DIMENSION(jpi,jpj) ::   zCdN, zCeN, zChN        ! 10m neutral latent/sensible coefficient
+      REAL(wp), DIMENSION(jpi,jpj) ::   zsqrt_Cd, zsqrt_CdN   ! root square of Cd and Cd_neutral
       REAL(wp), DIMENSION(jpi,jpj) ::   zeta_u        ! stability parameter at height zu
-      REAL(wp), DIMENSION(jpi,jpj) ::   zpsi_h_u
       REAL(wp), DIMENSION(jpi,jpj) ::   ztmp0, ztmp1, ztmp2
-      REAL(wp), DIMENSION(jpi,jpj) ::   stab          ! stability test integer
-      !!----------------------------------------------------------------------------------
+      !!----------------------------------------------------------------------------------
+      nbit = nb_iter0
+      IF( PRESENT(nb_iter) ) nbit = nb_iter
+
       l_zt_equal_zu = ( ABS(zu - zt) < 0.01_wp ) ! testing "zu == zt" is risky with double precision
 
-      U_blk = MAX( 0.5_wp , U_zu )   !  relative wind speed at zu (normally 10m), we don't want to fall under 0.5 m/s
+      Ubzu = MAX( 0.5_wp , U_zu )   !  relative wind speed at zu (normally 10m), we don't want to fall under 0.5 m/s
 
       !! First guess of stability:
       ztmp0 = virt_temp(t_zt, q_zt) - virt_temp(sst, ssq) ! air-sea difference of virtual pot. temp. at zt
-      stab  = 0.5_wp + sign(0.5_wp,ztmp0)                           ! stab = 1 if dTv > 0  => STABLE, 0 if unstable
+      ztmp1 = 0.5_wp + SIGN(0.5_wp,ztmp0)                 ! ztmp1 = 1 if dTv > 0  => STABLE, 0 if unstable
 
       !! Neutral coefficients at 10m:
       IF( ln_cdgw ) THEN      ! wave drag case
          cdn_wave(:,:) = cdn_wave(:,:) + rsmall * ( 1._wp - tmask(:,:,1) )
-         ztmp0   (:,:) = cdn_wave(:,:)
+         zCdN   (:,:) = cdn_wave(:,:)
       ELSE
-      ztmp0 = cd_neutral_10m( U_blk )
+      zCdN = cd_n10_ncar( Ubzu )
       ENDIF
 
-      sqrt_Cd_n10 = SQRT( ztmp0 )
+      zsqrt_CdN = SQRT( zCdN )
 
       !! Initializing transf. coeff. with their first guess neutral equivalents :
-      Cd = ztmp0
-      Ce = 1.e-3_wp*( 34.6_wp * sqrt_Cd_n10 )
-      Ch = 1.e-3_wp*sqrt_Cd_n10*(18._wp*stab + 32.7_wp*(1._wp - stab))
-      stab = sqrt_Cd_n10   ! Temporaty array !!! stab == SQRT(Cd)
- 
+      Cd = zCdN
+      Ce = ce_n10_ncar( zsqrt_CdN )
+      Ch = ch_n10_ncar( zsqrt_CdN , ztmp1 )   ! ztmp1 is stability (1/0)
+      zsqrt_Cd = zsqrt_CdN
+
       IF( ln_cdgw ) THEN
-	Cen = Ce
-	Chn = Ch
+         zCeN = Ce
+         zChN = Ch
       ENDIF
 
-      !! First guess of temperature and humidity at height zu:
+      !! Initializing values at z_u with z_t values:
       t_zu = MAX( t_zt ,  180._wp )   ! who knows what's given on masked-continental regions...
       q_zu = MAX( q_zt , 1.e-6_wp )   !               "
 
+
       !! ITERATION BLOCK
-      DO j_itt = 1, nb_itt
+      DO jit = 1, nbit
          !
          ztmp1 = t_zu - sst   ! Updating air/sea differences
          ztmp2 = q_zu - ssq
 
-         ! Updating turbulent scales :   (L&Y 2004 eq. (7))
-         ztmp0 = stab*U_blk       ! u*       (stab == SQRT(Cd))
-         ztmp1 = Ch/stab*ztmp1    ! theta*   (stab == SQRT(Cd))
-         ztmp2 = Ce/stab*ztmp2    ! q*       (stab == SQRT(Cd))
-
-         ! Estimate the inverse of Monin-Obukov length (1/L) at height zu:
+         ! Updating turbulent scales :   (L&Y 2004 Eq. (7))
+         ztmp0 = zsqrt_Cd*Ubzu       ! u*
+         ztmp1 = Ch/zsqrt_Cd*ztmp1    ! theta*
+         ztmp2 = Ce/zsqrt_Cd*ztmp2    ! q*
+
+         ! Estimate the inverse of Obukov length (1/L) at height zu:
          ztmp0 = One_on_L( t_zu, q_zu, ztmp0, ztmp1, ztmp2 )
-         
+
          !! Stability parameters :
          zeta_u   = zu*ztmp0
-         zeta_u = sign( min(abs(zeta_u),10._wp), zeta_u )
-         zpsi_h_u = psi_h( zeta_u )
-
-         !! Shifting temperature and humidity at zu (L&Y 2004 eq. (9b-9c))
+         zeta_u   = sign( min(abs(zeta_u),10._wp), zeta_u )
+
+         !! Shifting temperature and humidity at zu (L&Y 2004 Eq. (9b-9c))
          IF( .NOT. l_zt_equal_zu ) THEN
-            !! Array 'stab' is free for the moment so using it to store 'zeta_t'
-            stab = zt*ztmp0
-            stab = SIGN( MIN(ABS(stab),10._wp), stab )  ! Temporaty array stab == zeta_t !!!
-            stab = LOG(zt/zu) + zpsi_h_u - psi_h(stab)                   ! stab just used as temp array again!
-            t_zu = t_zt - ztmp1/vkarmn*stab    ! ztmp1 is still theta*  L&Y 2004 eq.(9b)
-            q_zu = q_zt - ztmp2/vkarmn*stab    ! ztmp2 is still q*      L&Y 2004 eq.(9c)
-            q_zu = max(0._wp, q_zu)
-         ENDIF
-
-         ! Update neutral wind speed at 10m and neutral Cd at 10m (L&Y 2004 eq. 9a)...
+            ztmp0 = zt*ztmp0 ! zeta_t !
+            ztmp0 = SIGN( MIN(ABS(ztmp0),10._wp), ztmp0 )  ! Temporaty array ztmp0 == zeta_t !!!
+            ztmp0 = LOG(zt/zu) + psi_h_ncar(zeta_u) - psi_h_ncar(ztmp0)                   ! ztmp0 just used as temp array again!
+            t_zu = t_zt - ztmp1/vkarmn*ztmp0    ! ztmp1 is still theta*  L&Y 2004 Eq. (9b)
+            !!
+            q_zu = q_zt - ztmp2/vkarmn*ztmp0    ! ztmp2 is still q*      L&Y 2004 Eq. (9c)
+            q_zu = MAX(0._wp, q_zu)
+         END IF
+
+         ! Update neutral wind speed at 10m and neutral Cd at 10m (L&Y 2004 Eq. 9a)...
          !   In very rare low-wind conditions, the old way of estimating the
          !   neutral wind speed at 10m leads to a negative value that causes the code
          !   to crash. To prevent this a threshold of 0.25m/s is imposed.
-         ztmp2 = psi_m(zeta_u)
+         ztmp2 = psi_m_ncar(zeta_u)
          IF( ln_cdgw ) THEN      ! surface wave case
-            stab = vkarmn / ( vkarmn / sqrt_Cd_n10 - ztmp2 )  ! (stab == SQRT(Cd))
-            Cd   = stab * stab
-            ztmp0 = (LOG(zu/10._wp) - zpsi_h_u) / vkarmn / sqrt_Cd_n10
-            ztmp2 = stab / sqrt_Cd_n10   ! (stab == SQRT(Cd))
-            ztmp1 = 1._wp + Chn * ztmp0     
-            Ch    = Chn * ztmp2 / ztmp1  ! L&Y 2004 eq. (10b)
-            ztmp1 = 1._wp + Cen * ztmp0
-            Ce    = Cen * ztmp2 / ztmp1  ! L&Y 2004 eq. (10c)
+            zsqrt_Cd = vkarmn / ( vkarmn / zsqrt_CdN - ztmp2 )
+            Cd   = zsqrt_Cd * zsqrt_Cd
+            ztmp0 = (LOG(zu/10._wp) - psi_h_ncar(zeta_u)) / vkarmn / zsqrt_CdN
+            ztmp2 = zsqrt_Cd / zsqrt_CdN
+            ztmp1 = 1._wp + zChN * ztmp0
+            Ch    = zChN * ztmp2 / ztmp1  ! L&Y 2004 eq. (10b)
+            ztmp1 = 1._wp + zCeN * ztmp0
+            Ce    = zCeN * ztmp2 / ztmp1  ! L&Y 2004 eq. (10c)
 
          ELSE
-         ! Update neutral wind speed at 10m and neutral Cd at 10m (L&Y 2004 eq. 9a)...
-         !   In very rare low-wind conditions, the old way of estimating the
-         !   neutral wind speed at 10m leads to a negative value that causes the code
-         !   to crash. To prevent this a threshold of 0.25m/s is imposed.
-         ztmp0 = MAX( 0.25_wp , U_blk/(1._wp + sqrt_Cd_n10/vkarmn*(LOG(zu/10._wp) - ztmp2)) ) ! U_n10 (ztmp2 == psi_m(zeta_u))
-         ztmp0 = cd_neutral_10m(ztmp0)                                               ! Cd_n10
-         Cdn(:,:) = ztmp0
-         sqrt_Cd_n10 = sqrt(ztmp0)
-
-         stab    = 0.5_wp + sign(0.5_wp,zeta_u)                        ! update stability
-         Cx_n10  = 1.e-3_wp*sqrt_Cd_n10*(18._wp*stab + 32.7_wp*(1._wp - stab))  ! L&Y 2004 eq. (6c-6d)    (Cx_n10 == Ch_n10)
-         Chn(:,:) = Cx_n10
+         ztmp0 = MAX( 0.25_wp , UN10_from_CD(zu, Ubzu, Cd, ppsi=ztmp2) ) ! U_n10 (ztmp2 == psi_m_ncar(zeta_u))
+
+         zCdN = cd_n10_ncar(ztmp0)
+         zsqrt_CdN = sqrt(zCdN)
 
          !! Update of transfer coefficients:
-         ztmp1 = 1._wp + sqrt_Cd_n10/vkarmn*(LOG(zu/10._wp) - ztmp2)   ! L&Y 2004 eq. (10a) (ztmp2 == psi_m(zeta_u))
-         Cd      = ztmp0 / ( ztmp1*ztmp1 )
-         stab = SQRT( Cd ) ! Temporary array !!! (stab == SQRT(Cd))
-
-         ztmp0 = (LOG(zu/10._wp) - zpsi_h_u) / vkarmn / sqrt_Cd_n10
-         ztmp2 = stab / sqrt_Cd_n10   ! (stab == SQRT(Cd))
-         ztmp1 = 1._wp + Cx_n10*ztmp0    ! (Cx_n10 == Ch_n10)
-         Ch  = Cx_n10*ztmp2 / ztmp1   ! L&Y 2004 eq. (10b)
-
-         Cx_n10  = 1.e-3_wp * (34.6_wp * sqrt_Cd_n10)  ! L&Y 2004 eq. (6b)    ! Cx_n10 == Ce_n10
-         Cen(:,:) = Cx_n10
-         ztmp1 = 1._wp + Cx_n10*ztmp0
-         Ce  = Cx_n10*ztmp2 / ztmp1  ! L&Y 2004 eq. (10c)
+
+         !! C_D
+         ztmp1  = 1._wp + zsqrt_CdN/vkarmn*(LOG(zu/10._wp) - ztmp2)   ! L&Y 2004 Eq. (10a) (ztmp2 == psi_m(zeta_u))
+         Cd     = MAX( zCdN / ( ztmp1*ztmp1 ), Cx_min )
+
+         !! C_H and C_E
+         zsqrt_Cd = SQRT( Cd )
+         ztmp0 = ( LOG(zu/10._wp) - psi_h_ncar(zeta_u) ) / vkarmn / zsqrt_CdN
+         ztmp2 = zsqrt_Cd / zsqrt_CdN
+
+         ztmp1 = 0.5_wp + SIGN(0.5_wp,zeta_u)                                ! update stability
+         zChN  = 1.e-3_wp * zsqrt_CdN*(18._wp*ztmp1 + 32.7_wp*(1._wp - ztmp1))  ! L&Y 2004 eq. (6c-6d)
+         zCeN  = 1.e-3_wp * (34.6_wp * zsqrt_CdN)                             ! L&Y 2004 eq. (6b)
+
+         Ch    = MAX( zChN*ztmp2 / ( 1._wp + zChN*ztmp0 ) , Cx_min ) ! L&Y 2004 eq. (10b)
+         Ce    = MAX( zCeN*ztmp2 / ( 1._wp + zCeN*ztmp0 ) , Cx_min ) ! L&Y 2004 eq. (10c)
+
          ENDIF
 
-      END DO !DO j_itt = 1, nb_itt
+      END DO !DO jit = 1, nbit
+
+      IF(PRESENT(CdN)) CdN(:,:) = zCdN(:,:)
+      IF(PRESENT(CeN)) CeN(:,:) = zCeN(:,:)
+      IF(PRESENT(ChN)) ChN(:,:) = zChN(:,:)
 
    END SUBROUTINE turb_ncar
 
 
-   FUNCTION cd_neutral_10m( pw10 )
-      !!----------------------------------------------------------------------------------      
+   FUNCTION cd_n10_ncar( pw10 )
+      !!----------------------------------------------------------------------------------
       !! Estimate of the neutral drag coefficient at 10m as a function
       !! of neutral wind  speed at 10m
       !!
-      !! Origin: Large & Yeager 2008 eq.(11a) and eq.(11b)
+      !! Origin: Large & Yeager 2008, Eq. (11)
       !!
       !! ** Author: L. Brodeau, june 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
       !!----------------------------------------------------------------------------------
       REAL(wp), DIMENSION(jpi,jpj), INTENT(in) :: pw10           ! scalar wind speed at 10m (m/s)
-      REAL(wp), DIMENSION(jpi,jpj)             :: cd_neutral_10m
+      REAL(wp), DIMENSION(jpi,jpj)             :: cd_n10_ncar
       !
       INTEGER  ::     ji, jj     ! dummy loop indices
@@ -242,27 +240,60 @@
       !
       DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
-         !
-         zw  = pw10(ji,jj)
-         zw6 = zw*zw*zw
-         zw6 = zw6*zw6
-         !
-         ! When wind speed > 33 m/s => Cyclone conditions => special treatment
-         zgt33 = 0.5_wp + SIGN( 0.5_wp, (zw - 33._wp) )   ! If pw10 < 33. => 0, else => 1
-         !
-         cd_neutral_10m(ji,jj) = 1.e-3_wp * ( &
-            &       (1._wp - zgt33)*( 2.7_wp/zw + 0.142_wp + zw/13.09_wp - 3.14807E-10_wp*zw6) & ! wind <  33 m/s
-            &      +    zgt33   *      2.34_wp )                                                 ! wind >= 33 m/s
-         !
-         cd_neutral_10m(ji,jj) = MAX(cd_neutral_10m(ji,jj), 1.E-6_wp)
-         !
+            !
+            zw  = pw10(ji,jj)
+            zw6 = zw*zw*zw
+            zw6 = zw6*zw6
+            !
+            ! When wind speed > 33 m/s => Cyclone conditions => special treatment
+            zgt33 = 0.5_wp + SIGN( 0.5_wp, (zw - 33._wp) )   ! If pw10 < 33. => 0, else => 1
+            !
+            cd_n10_ncar(ji,jj) = 1.e-3_wp * ( &
+               &       (1._wp - zgt33)*( 2.7_wp/zw + 0.142_wp + zw/13.09_wp - 3.14807E-10_wp*zw6) & ! wind <  33 m/s
+               &      +    zgt33   *      2.34_wp )                                                 ! wind >= 33 m/s
+            !
+            cd_n10_ncar(ji,jj) = MAX( cd_n10_ncar(ji,jj), Cx_min )
+            !
       END_2D
       !
-   END FUNCTION cd_neutral_10m
-
-
-   FUNCTION psi_m( pzeta )
+   END FUNCTION cd_n10_ncar
+
+
+   FUNCTION ch_n10_ncar( psqrtcdn10 , pstab )
+      !!----------------------------------------------------------------------------------
+      !! Estimate of the neutral heat transfer coefficient at 10m      !!
+      !! Origin: Large & Yeager 2008, Eq. (9) and (12)
+
+      !!----------------------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj)             :: ch_n10_ncar
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in) :: psqrtcdn10 ! sqrt( CdN10 )
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in) :: pstab      ! stable ABL => 1 / unstable ABL => 0
+      !!----------------------------------------------------------------------------------
+      IF( ANY(pstab < -0.00001) .OR. ANY(pstab >  1.00001) ) THEN
+         PRINT *, 'ERROR: ch_n10_ncar@mod_blk_ncar.f90: pstab ='
+         PRINT *, pstab
+         STOP
+      END IF
+      !
+      ch_n10_ncar = MAX( 1.e-3_wp * psqrtcdn10*( 18._wp*pstab + 32.7_wp*(1._wp - pstab) )  , Cx_min )   ! Eq. (9) & (12) Large & Yeager, 2008
+      !
+   END FUNCTION ch_n10_ncar
+
+   FUNCTION ce_n10_ncar( psqrtcdn10 )
+      !!----------------------------------------------------------------------------------
+      !! Estimate of the neutral heat transfer coefficient at 10m      !!
+      !! Origin: Large & Yeager 2008, Eq. (9) and (13)
+      !!----------------------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj)             :: ce_n10_ncar
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in) :: psqrtcdn10 ! sqrt( CdN10 )
+      !!----------------------------------------------------------------------------------
+      ce_n10_ncar = MAX( 1.e-3_wp * ( 34.6_wp * psqrtcdn10 ) , Cx_min )
+      !
+   END FUNCTION ce_n10_ncar
+
+
+   FUNCTION psi_m_ncar( pzeta )
       !!----------------------------------------------------------------------------------
       !! Universal profile stability function for momentum
-      !!    !! Psis, L&Y 2004 eq. (8c), (8d), (8e)
+      !!    !! Psis, L&Y 2004, Eq. (8c), (8d), (8e)
       !!
       !! pzeta : stability paramenter, z/L where z is altitude measurement
@@ -271,28 +302,36 @@
       !! ** Author: L. Brodeau, June 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
       !!----------------------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj) :: psi_m
+      REAL(wp), DIMENSION(jpi,jpj) :: psi_m_ncar
       REAL(wp), DIMENSION(jpi,jpj), INTENT(in) :: pzeta
       !
       INTEGER  ::   ji, jj    ! dummy loop indices
-      REAL(wp) :: zx2, zx, zstab   ! local scalars
+      REAL(wp) :: zta, zx2, zx, zpsi_unst, zpsi_stab,  zstab   ! local scalars
       !!----------------------------------------------------------------------------------
       DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
-         zx2 = SQRT( ABS( 1._wp - 16._wp*pzeta(ji,jj) ) )
-         zx2 = MAX( zx2 , 1._wp )
-         zx  = SQRT( zx2 )
-         zstab = 0.5_wp + SIGN( 0.5_wp , pzeta(ji,jj) )
-         !
-         psi_m(ji,jj) =        zstab  * (-5._wp*pzeta(ji,jj))       &          ! Stable
-            &          + (1._wp - zstab) * (2._wp*LOG((1._wp + zx)*0.5_wp)   &          ! Unstable
-            &               + LOG((1._wp + zx2)*0.5_wp) - 2._wp*ATAN(zx) + rpi*0.5_wp)  !    "
-         !
+            zta = pzeta(ji,jj)
+            !
+            zx2 = SQRT( ABS(1._wp - 16._wp*zta) )  ! (1 - 16z)^0.5
+            zx2 = MAX( zx2 , 1._wp )
+            zx  = SQRT(zx2)                          ! (1 - 16z)^0.25
+            zpsi_unst = 2._wp*LOG( (1._wp + zx )*0.5_wp )   &
+               &            + LOG( (1._wp + zx2)*0.5_wp )   &
+               &          - 2._wp*ATAN(zx) + rpi*0.5_wp
+            !
+            zpsi_stab = -5._wp*zta
+            !
+            zstab = 0.5_wp + SIGN(0.5_wp, zta) ! zta > 0 => zstab = 1
+            !
+            psi_m_ncar(ji,jj) =          zstab  * zpsi_stab &  ! (zta > 0) Stable
+               &              + (1._wp - zstab) * zpsi_unst    ! (zta < 0) Unstable
+            !
+            !
       END_2D
-   END FUNCTION psi_m
-
-
-   FUNCTION psi_h( pzeta )
+   END FUNCTION psi_m_ncar
+
+
+   FUNCTION psi_h_ncar( pzeta )
       !!----------------------------------------------------------------------------------
       !! Universal profile stability function for temperature and humidity
-      !!    !! Psis, L&Y 2004 eq. (8c), (8d), (8e)
+      !!    !! Psis, L&Y 2004, Eq. (8c), (8d), (8e)
       !!
       !! pzeta : stability paramenter, z/L where z is altitude measurement
@@ -301,21 +340,28 @@
       !! ** Author: L. Brodeau, June 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
       !!----------------------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj) :: psi_h
+      REAL(wp), DIMENSION(jpi,jpj) :: psi_h_ncar
       REAL(wp), DIMENSION(jpi,jpj), INTENT(in) :: pzeta
       !
       INTEGER  ::   ji, jj     ! dummy loop indices
-      REAL(wp) :: zx2, zstab  ! local scalars
+      REAL(wp) :: zta, zx2, zpsi_unst, zpsi_stab, zstab  ! local scalars
       !!----------------------------------------------------------------------------------
       !
       DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
-         zx2 = SQRT( ABS( 1._wp - 16._wp*pzeta(ji,jj) ) )
-         zx2 = MAX( zx2 , 1._wp )
-         zstab = 0.5_wp + SIGN( 0.5_wp , pzeta(ji,jj) )
-         !
-         psi_h(ji,jj) =         zstab  * (-5._wp*pzeta(ji,jj))        &  ! Stable
-            &           + (1._wp - zstab) * (2._wp*LOG( (1._wp + zx2)*0.5_wp ))   ! Unstable
-         !
+            !
+            zta = pzeta(ji,jj)
+            !
+            zx2 = SQRT( ABS(1._wp - 16._wp*zta) )  ! (1 -16z)^0.5
+            zx2 = MAX( zx2 , 1._wp )
+            zpsi_unst = 2._wp*LOG( 0.5_wp*(1._wp + zx2) )
+            !
+            zpsi_stab = -5._wp*zta
+            !
+            zstab = 0.5_wp + SIGN(0.5_wp, zta) ! zta > 0 => zstab = 1
+            !
+            psi_h_ncar(ji,jj) =          zstab  * zpsi_stab &  ! (zta > 0) Stable
+               &              + (1._wp - zstab) * zpsi_unst    ! (zta < 0) Unstable
+            !
       END_2D
-   END FUNCTION psi_h
+   END FUNCTION psi_h_ncar
 
    !!======================================================================
Index: /NEMO/trunk/src/OCE/SBC/sbcblk_skin_coare.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcblk_skin_coare.F90	(revision 14071)
+++ /NEMO/trunk/src/OCE/SBC/sbcblk_skin_coare.F90	(revision 14072)
@@ -13,5 +13,5 @@
    !! ** Author: L. Brodeau, November 2019 / AeroBulk (https://github.com/brodeau/aerobulk)
    !!----------------------------------------------------------------------
-   !! History :  4.x  !  2019-11  (L.Brodeau)   Original code
+   !! History :  4.0  !  2019-11  (L.Brodeau)   Original code
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers
@@ -20,5 +20,5 @@
    USE sbc_oce         ! Surface boundary condition: ocean fields
 
-   USE sbcblk_phy      ! misc. functions for marine ABL physics (rho_air, q_sat, bulk_formula, etc)
+   USE sbc_phy         ! Catalog of functions for physical/meteorological parameters in the marine boundary layer
 
    USE sbcdcy          !#LB: to know hour of dawn and dusk: rdawn_dcy and rdusk_dcy (needed in WL_COARE)
Index: /NEMO/trunk/src/OCE/SBC/sbcblk_skin_ecmwf.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcblk_skin_ecmwf.F90	(revision 14071)
+++ /NEMO/trunk/src/OCE/SBC/sbcblk_skin_ecmwf.F90	(revision 14072)
@@ -28,5 +28,6 @@
    !! ** Author: L. Brodeau, November 2019 / AeroBulk (https://github.com/brodeau/aerobulk)
    !!----------------------------------------------------------------------
-   !! History :  4.x  !  2019-11  (L.Brodeau)   Original code
+   !! History :  4.0  ! 2019-11  (L.Brodeau)   Original code
+   !!            4.2  ! 2020-12  (L. Brodeau) Introduction of various air-ice bulk parameterizations + improvements
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers
@@ -35,5 +36,5 @@
    USE sbc_oce         ! Surface boundary condition: ocean fields
 
-   USE sbcblk_phy      ! misc. functions for marine ABL physics (rho_air, q_sat, bulk_formula, etc)
+   USE sbc_phy         ! Catalog of functions for physical/meteorological parameters in the marine boundary layer
 
    USE lib_mpp         ! distribued memory computing library
@@ -160,8 +161,8 @@
       REAL(wp) :: zalfa     !: thermal expansion coefficient of sea-water [1/K]
       REAL(wp) :: zdTwl_b, zdTwl_n  !: temp. diff. between "almost surface (right below viscous layer) and bottom of WL
-      REAL(wp) :: zfr, zeta 
-      REAL(wp) :: zusw, zusw2 
-      REAL(wp) :: zLa, zfLa 
-      REAL(wp) :: flg, zwf, zQabs 
+      REAL(wp) :: zfr, zeta
+      REAL(wp) :: zusw, zusw2
+      REAL(wp) :: zLa, zfLa
+      REAL(wp) :: flg, zwf, zQabs
       REAL(wp) :: ZA, ZB, zL1, zL2
       REAL(wp) :: zcst0, zcst1, zcst2, zcst3
